<script lang="ts">
/* eslint-disable */

import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../common/content-types';
import { demoDataHelper } from '../services/demo.service';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

function mapDemo(items) {
  const { pageContent } = items[0].fields;
  const seoMetadata = items[0].fields.seoMetadata[0].fields;

  const demo = demoDataHelper(pageContent);
  const metadata = {
    title: seoMetadata.title,
    description: seoMetadata.description,
    og_title: seoMetadata.title,
    og_description: seoMetadata.description,
  };

  return { demo, metadata };
}

export default Vue.extend({
  mixins: [
    LivePreviewMixin,
    FooterEditLinkMixin,
    UseLiteVimeo,
    UseLocalizedVideoSubtitles,
  ],
  async asyncData({ i18n }) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'demo',
        include: 3,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const spaceId = response.items[0].sys.space.sys.id;
      const entryId = response.items[0].sys.id;

      const { demo, metadata } = mapDemo(response.items);

      return { items: response.items, demo, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },

  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) => {
          const { demo, metadata } = mapDemo(updatedData);
          this.demo = demo;
          this.metadata = metadata;
        },
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div>
    <div class="demo">
      <SlpContainer>
        <SlpRow class="grayBackground">
          <SlpColumn class="text__container" :cols="6">
            <SlpTypography
              class="slp-mb-16 text__header"
              variant="heading2-bold"
              tag="h1"
            >
              {{ demo.header }}
            </SlpTypography>
            <SlpTypography
              class="slp-mb-16 text__subtitle"
              variant="heading4"
              tag="h2"
            >
              {{ demo.subtitle }}
            </SlpTypography>
          </SlpColumn>
          <SlpColumn class="column" :cols="6">
            <lite-vimeo
              :videoid="
                getVimeoVideoId(createVideoSource(demo.demo_video.video_url))
              "
            ></lite-vimeo>
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </div>
    <SlpContainer class="slp-my-64">
      <SlpTypography class="slp-mb-16 content" tag="div">
        <div v-html="$md.render(demo.content)"></div>
      </SlpTypography>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.demo {
  background-color: $color-surface-800;
  align-items: center;

  .grayBackground {
    padding: $spacing-32 0;
    align-items: center;
  }

  .column {
    width: 100%;
  }
}

.content:deep {
  ul {
    padding-left: $spacing-24;

    li {
      margin-bottom: 1rem;
      font-size: $text-body-2;
      line-height: $line-height-body-2;
      display: block;
      position: relative;
      padding-left: 8px;

      &::before {
        content: '';
        background: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3E%3Cpath fill='%237759c2' fill-rule='evenodd' clip-rule='evenodd' d='M14.5 8a6.5 6.5 0 11-13 0 6.5 6.5 0 0113 0zM16 8A8 8 0 110 8a8 8 0 0116 0zm-4.22-1.72a.75.75 0 00-1.06-1.06L6.75 9.19 5.53 7.97a.75.75 0 00-1.06 1.06l1.75 1.75a.75.75 0 001.06 0l4.5-4.5z'/%3E%3C/svg%3E ");
        background-size: 16px 16px;
        width: 16px;
        height: 16px;
        position: absolute;
        left: -20px;
        top: 50%;
        transform: translateY(-50%);
      }
    }
  }

  p {
    font-size: $text-heading-4;
    line-height: $line-height-heading-4;
    margin-bottom: $spacing-16;
  }
}
</style>
